#include <linux/module.h>
#include <linux/kernel.h>
#include <rtl_fifo.h>
#include <linux/rtl.h>
#include <asm/rtl_time.h>
#include <rtl_sched.h>
#include <asm/io.h>
#include <linux/cons.h>
#include "common.h"

#define TIMEOUT 100000
#define SKIP 20000
#define PERIOD 200


#define PERIODIC_MODE 0

RT_TASK tsk;
RTIME min_diff;
RTIME max_diff;
RTIME expected;
struct sample samp;
int skip;

void fun(int t) {

	RTIME diff,now;

	while (1) {
                min_diff = 100000; max_diff = -100000;
		for (skip = 0; skip < SKIP; skip++) {

			now = rt_get_time();
			diff = now - expected;
			if (diff < min_diff) {
				min_diff = diff;
			}
			if (diff > max_diff) {
				max_diff = diff;
			}

			expected += PERIOD;
			rt_task_wait();
		}
		samp.min = min_diff;
		samp.max = max_diff;
		rtf_put(0, &samp, sizeof(samp));
	}
}


int init_module(void)
{
	RTIME t;
	min_diff = 1000000000;
	max_diff = -1000000000;
        conpr ("Starting measurement module\n");
	rtf_create(0, 4000);

	rt_task_init(&tsk, fun, 1, 3000, 2);
	if (PERIODIC_MODE) {
		t = rtl_set_periodic_mode(PERIOD);
		if (t == RT_TIME_END) {
			conpr("Setting periodic mode failed\n");
			t = rt_get_time();
		}
	} else {
		rtl_set_oneshot_mode();
		t = rt_get_time();
	}
		

	expected = t + PERIOD;
	rt_task_make_periodic(&tsk, expected, PERIOD);

	return 0;
}


void cleanup_module(void)
{
	rt_task_delete(&tsk);
	
	rtf_destroy(0);

}

