#include <linux/module.h>
#include <linux/kernel.h>
#include <rtl_fifo.h>
#include <asm/rt_irq.h>
#include <asm/rt_time.h>
#include <rtl_sched.h>
#include <asm/io.h>
#include <linux/cons.h>
#include "common.h"

#define TIMEOUT 100000
#define SKIP 5000
#define PERIOD 500


#define PERIODIC_MODE 0

RT_TASK mytask;
RTIME min_diff;
RTIME max_diff;
RTIME last;
struct sample samp;
int skip;

void fun(int t) {

	RTIME diff, now;

	while (1) {
                min_diff = 100000; max_diff = -100000;
		for (skip = 0; skip < SKIP; skip++) {

			now = rt_get_time();
			diff = now - last - PERIOD;

			if (diff < min_diff) {
				min_diff = diff;
			}
			if (diff > max_diff) {
				max_diff = diff;
			}

			last = now;
			rt_task_wait();
		}
		samp.min = min_diff;
		samp.max = max_diff;
		rtf_put(0, &samp, sizeof(samp));
	}
}


int init_module(void)
{
        printk("Starting measurement module\n");
	rtf_create(0, 4000);

	rt_task_init(&mytask, fun, 1, 3000, 4);
	if (PERIODIC_MODE) {
		last = rt_set_periodic_mode(PERIOD);
	} else {
		rt_set_oneshot_mode();
		last = rt_get_time();
	}
		
	rt_task_make_periodic(&mytask, last + PERIOD, PERIOD);

	return 0;
}


void cleanup_module(void)
{
	rt_task_delete(&mytask);
	
	rtf_destroy(0);

}

